package com.gct.aoid;

import com.gct.common.security.annotation.EnableGCTServiceSecurity;
import com.spring4all.swagger.EnableSwagger2Doc;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.ImportAutoConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.ribbon.RibbonAutoConfiguration;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.cloud.openfeign.FeignAutoConfiguration;
import org.springframework.cloud.openfeign.ribbon.FeignRibbonClientAutoConfiguration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;

@SpringBootApplication
//@MapperScan(basePackageClasses = com.gct.aoid.mapper.AoidCalprotaskqueueMapper.class)//要扫描的dao包
@EnableSwagger2Doc //启用swagger注解
@EnableFeignClients
@EnableDiscoveryClient//开启服务注册
//@EnableScheduling//开启定时任务
@ImportAutoConfiguration({RibbonAutoConfiguration.class, FeignRibbonClientAutoConfiguration.class, FeignAutoConfiguration.class})
@EnableGCTServiceSecurity
@EnableTransactionManagement
public class ProductionCalApplication {

    public static void main(String[] args) {
        SpringApplication.run(ProductionCalApplication.class, args);
    }

}
