package com.gct.aoid.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2021-01-31
 */
@Api(value = "AoidSinglegtYieldController", description = "功图量液")
@RestController
//@ResponseBody
@RequestMapping("/aoidSinglegtYield")

public class AoidSinglegtYieldController {

    @Autowired  
    public AoidSinglegtYieldService aoidSinglegtYieldService;

    /*@ApiOperation(value = "分页查询", notes = "功图平铺")
    @GetMapping("/pages")
    public Result findAoidSinglegtYieldByPages(
            @ApiParam(name = "pageNum", value = "当前页", required = true) @RequestParam("pageNum") Integer pageNum,
            @ApiParam(name = "pageSize", value = "页大小", required = true) @RequestParam("pageSize") Integer pageSize,
            @ApiParam(name = "jh", value = "井号") @RequestParam(value = "jh", required = false) String jh
    ) {
        return aoidSinglegtYieldService.findAoidSinglegtYieldByPages(pageNum, pageSize, jh);
    }*/



    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息" ,notes = "根据井号和日期时间段查询量液的基本信息")
    @PostMapping("/getAoidSinglegtYieldInfo")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(@RequestBody AoidYeildVo aoidYeildVo){
        List<Map<String, Object>> list =  aoidSinglegtYieldService.getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(
                aoidYeildVo.getWellId(),
                aoidYeildVo.getStartDate());
        return list==null||list.size()==0?Result.error("未找到"):Result.ok(list);
    }

    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息--分页" ,notes = "根据井号和日期时间段查询量液的基本信息--分页")
    @PostMapping("/getAoidSinglegtYieldInfoByPages")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(@RequestBody AoidYeildVo aoidYeildVo) throws ParseException {
        String datePattern = "\\d{4}-\\d{1,2}-\\d{1,2}";
        if(aoidYeildVo.getStartDate()==null){
            LocalDate now = LocalDate.now();
            aoidYeildVo.setStartDate(now.format(DateTimeFormatter.ISO_DATE));
            aoidYeildVo.setEndDate(now.plusDays(1).format(DateTimeFormatter.ISO_DATE));
        }
        if (aoidYeildVo.getStartDate()==null||aoidYeildVo.getEndDate()==null ||!aoidYeildVo.getStartDate().matches(datePattern) || !aoidYeildVo.getEndDate().matches(datePattern))
            return Result.error("日期格式有误");

        Page<Map<String,Object>> mapPage =  aoidSinglegtYieldService.getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(
                aoidYeildVo.getWellId(),
                aoidYeildVo.getStartDate(),
                aoidYeildVo.getEndDate(),
                aoidYeildVo.getPage(),
                aoidYeildVo.getSize());
        return mapPage==null||mapPage.getSize()==0?Result.error("未找到"):Result.ok(mapPage);
    }
}

