package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

import java.time.LocalDateTime;
import java.io.Serializable;
import java.time.format.DateTimeFormatter;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author Lloyd
 * @since 2021-02-01
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "AoidCalprotaskqueue对象", description = "")
@TableName(schema = "aoid", value = "aoid_calprotaskqueue")
public class AoidCalprotaskqueue extends Model<AoidCalprotaskqueue> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "示功图id")
    private String sgtbaseparamId;

    @ApiModelProperty(value = "诊断结果id")
    private String diagnoseresultId;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createtime;

    @TableId
    @ApiModelProperty(value = "唯一id")
    private String id;

    @ApiModelProperty(value = "status")
    private int status;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    /*
    yyyy-MM-dd HH:mm:ss
     */
    private String createTimeFormatted;

    public void setCreatetime(LocalDateTime createtime) {
        this.createtime = createtime;
        if (createtime != null)
            this.createTimeFormatted = createtime.format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
    }

    /**
     * 任务状态说明
     */
    public enum TaskStatus {
        ADDED(-1, "待计算"),
        LOCKED(0, "计算中"),
        COMPLETED(1, "计算完成");
        @Getter
        private int code;
        @Getter
        private String dec;

        TaskStatus(int _code, String _dec) {
            this.code = _code;
            this.dec = _dec;
        }

    }
}
