package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;

/**
 * @Author: Jyx
 * @Since: 2021/1/28 17:52
 */
@Data
@ApiModel(value = "AoidDailyYield对象",description = "量液日产量存储数据")
@TableName("aoid.aoid_daily_yield")
public class AoidDailyYield {
    @ApiModelProperty(value = "井号")
    private String wellCommonName;

    @ApiModelProperty(value = "井Id")
    private String wellId;

    @ApiModelProperty(value = "日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:ss:mm" , timezone = "GMT+8")
    private LocalDateTime prodDate;

    @ApiModelProperty(value = "日产液量 t(实际产量)")
    private double liqProdDaily;

    @ApiModelProperty(value = "日产油量 t")
    private double oilProdDaily;

    @ApiModelProperty(value = "日产水量 t")
    private double waterProdDaily;

    @ApiModelProperty(value = "日产气量 m^3")
    private double gasProdDaily;

    @ApiModelProperty(value = "泵效")
    private double bx;

    @ApiModelProperty(value = "理论排量")
    private double llpl;

    @ApiModelProperty(value = "生产时间")
    private double prodTime;

    @ApiModelProperty(value = "产量系数")
    private double clxs;

    @ApiModelProperty(value = "冲程")
    private double stroke;

    @ApiModelProperty(value = "冲次")
    private double frequence;

    @ApiModelProperty(value = "含水率 %")
    private double waterCut;

    @ApiModelProperty(value = "泵径")
    private double bj;

    @ApiModelProperty(value = "泵深")
    private double bs;

    @ApiModelProperty(value = "沉没度")
    private double cmd;

    @ApiModelProperty(value = "油嘴直径")
    private double yz;

    @ApiModelProperty(value = "生产时间")
    private double scsj;

    @ApiModelProperty(value = "油压")
    private double yy;

    @ApiModelProperty(value = "回压")
    private double hy;

    @ApiModelProperty(value = "套压")
    private double ty;

    @ApiModelProperty(value = "备注")
    private String bz;

    @ApiModelProperty(value = "是否异常")
    private double sfyc;

    @ApiModelProperty(value = "动液面")
    private double dym;

    @ApiModelProperty(value = "24小时产液量")
    private double rcy2;

    private double rcu2;

    private double rcs2;

    @ApiModelProperty(value = "日志产液量")
    private double a2LiqProdDaily;

    @ApiModelProperty(value = "日志产油量")
    private double a2OilProdDaily;

    @ApiModelProperty(value = "日志产水量")
    private double a2WaterProdDaily;

    @ApiModelProperty(value = "日志含水率 %")
    private double a2WaterCut;

    @ApiModelProperty(value = "有效功图数")
    private double yxgts;

    @ApiModelProperty(value = "错误功图数")
    private double errorgts;

    private String zdjg;

    @ApiModelProperty(value = "最小电压")
    private double djdy;

    @ApiModelProperty(value = "作业区")
    private String zyq;

    @ApiModelProperty(value = "计量站")
    private String jlz;

    @ApiModelProperty(value = "平均环境温度")
    private double hjwd;

    @ApiModelProperty(value = "仪表电流")
    private double ybdl;

    @ApiModelProperty(value = "设备号")
    private String sbh;

    @ApiModelProperty(value = "信号强度")
    private double xhqd;

    @ApiModelProperty(value = "压力仪表的今日压力平均值")
    private double yl;

    @ApiModelProperty(value = "日志备注")
    private String rzbz;

    @ApiModelProperty(value = "水密度")
    private double smd;

    @ApiModelProperty(value = "油密度")
    private double ymd;

    @ApiModelProperty(value = "汽油比")
    private double qyb;

    @TableField(exist = false)
    private String jq;




    @TableField(exist = false)
    private String  zd;

}
