package com.gct.aoid.job;

import com.gct.aoid.mapper.SumDataTaskMapper;
import com.gct.aoid.service.AoidWarningService;
import lombok.extern.slf4j.Slf4j;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * class name: CalLiqDailyJobDetail
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/21 上午10:24
 */
@Slf4j
public class AoidWarningJobDetail extends QuartzJobBean {
    @Autowired
    public AoidWarningService aoidWarningService;

    @Override
    protected void executeInternal(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        //sumDataTaskMapper= (SumDataTaskMapper)jobExecutionContext.getJobDetail().getJobDataMap().get("dao");
        String jobName = jobExecutionContext.getJobDetail().getJobDataMap().getString(JobDataKey.JobName.getDec());
        String jobGroup = jobExecutionContext.getJobDetail().getJobDataMap().getString(JobDataKey.JobGroup.getDec());
        LocalDateTime localDateTime = LocalDateTime.now();
        log.info("*===>AoidWarningJobDetail--JobName:{}--JobGroup:{},Time:{}", jobName, jobGroup, localDateTime.format(DateTimeFormatter.ISO_DATE_TIME));
        //String date = DateTimeFormatter.ofPattern("yyyy-MM-dd").format(localDateTime);
       // String dateTime = date + " 00:00:00";
        try {
            String isWarning = aoidWarningService.isWarning("H257", "2021-05-15");
            System.out.println(isWarning);
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("aoidWaring error");
        } finally {
            log.info("<===*AoidWarningJobDetail,Time:{}", localDateTime.format(DateTimeFormatter.ISO_DATE_TIME));
        }
    }

}
