package com.gct.aoid.job;

import com.gct.aoid.mapper.SumDataTaskMapper;
import lombok.extern.slf4j.Slf4j;
import org.quartz.Job;
import org.quartz.JobDetail;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.JobDetailFactoryBean;
import org.springframework.scheduling.quartz.QuartzJobBean;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeFormatterBuilder;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

/**
 * class name: CalLiqDailyJobDetail
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/5/21 上午10:24
 */
@Slf4j
public class CalLiqDailyJobDetail extends QuartzJobBean {
    @Autowired
    public SumDataTaskMapper sumDataTaskMapper;

    @Override
    protected void executeInternal(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        //sumDataTaskMapper= (SumDataTaskMapper)jobExecutionContext.getJobDetail().getJobDataMap().get("dao");
        String jobName = jobExecutionContext.getJobDetail().getJobDataMap().getString(JobDataKey.JobName.getDec());
        String jobGroup = jobExecutionContext.getJobDetail().getJobDataMap().getString(JobDataKey.JobGroup.getDec());
        LocalDateTime localDateTime = LocalDateTime.now();
        log.info("*===>CalLiqDailyJobDetail--JobName:{}--JobGroup:{},Time:{}", jobName, jobGroup, localDateTime.format(DateTimeFormatter.ISO_DATE_TIME));
        String date = DateTimeFormatter.ofPattern("yyyy-MM-dd").format(localDateTime);
        String dateTime = date + " 00:00:00";
        try {
            int int1 = sumDataTaskMapper.sumData(date, dateTime);//main logic
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("insert error");
        } finally {
            log.info("<===*calLiqDailyJobDetail,Time:{}", localDateTime.format(DateTimeFormatter.ISO_DATE_TIME));
        }
    }

}
