package com.gct.aoid.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.AoidDailyYield;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.common.core.result.Result;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author Jyx
 * @since 2021-01-28
 */
public interface AoidDailyYieldService extends IService<AoidDailyYield> {

    /**
     * 单井历史产量曲线/柱状图
     *
     * @param wellName 井号
     * @param beginDate 开始时间
     * @param endDate 截止时间
     * @return
     */
    Result getSingleHistoryYieldCurveOrChart(String wellName, String beginDate, String endDate);


    List<Map<String, Object>> getAoidDailyYieldInfoByWellIdAndPorDatePeriod(String wellId, String startDate);


    Page<Map<String,Object>> getAoidDailyYieldInfoByWellIdAndPorDatePeriodByPage(String wellId, String startDate, int pageSize, int pageNum);

    AoidDailyYield getDefaultData();




}
