package com.gct.aoid.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.entity.AoidGkModel;
import com.gct.aoid.mapper.AoidGkModelMapper;
import com.gct.aoid.service.AoidGkModelService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author Lloyd
 * @since 2021-01-31
 */
@Service
public class AoidGkModelServiceImpl extends ServiceImpl<AoidGkModelMapper, AoidGkModel> implements AoidGkModelService {
    @Autowired
    AoidGkModelMapper aoidGkModelMapper;

    //region 第一种方式实现:自定义缓存对象

    private Map<String, AoidGkModel> allGKModels = new HashMap<>();
    private Object lock = new Object();

    @Override
    public AoidGkModel getGKModelByResultType(String id) {
        if (allGKModels == null || allGKModels.size() == 0 || !allGKModels.containsKey(id))
            synchronized (lock) {
                if (allGKModels == null || allGKModels.size() == 0 || !allGKModels.containsKey(id)) {
                    List<AoidGkModel> gkModels = aoidGkModelMapper.selectList(new QueryWrapper<>());
                    if (gkModels == null || gkModels.size() == 0) return null;
                    allGKModels.clear();
                    for (AoidGkModel gkModel : gkModels) {
                        allGKModels.put(gkModel.getResult(), gkModel);
                    }
                }
            }
        if (allGKModels.containsKey(id))
            return allGKModels.get(id);
        return null;
    }
    //endregion

    //region TODO:第二种方式实现:使用Mybatis的二级缓存实现
   /* public AoidGkModel getGKModelByResultType(String id){
        allGKModels.
    }*/
    //endregion
}
