package com.gct.aoid.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.feignclient.WarningClint;
import com.gct.aoid.mapper.AoidDailyYieldMapper;
import com.gct.aoid.service.AoidWarningService;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;

public class AoidWarningServiceImpl implements AoidWarningService {

    @Autowired
    AoidDailyYieldMapper aoidDailyYieldMapper;
    @Autowired
    WarningClint warningClint;
    @Override
    public String isWarning(String wellId,String date) {

        //获取前一个月的平均产液量
        String avgForA2LiqProdDaily = aoidDailyYieldMapper.getAVGForA2LiqProdDaily(wellId, date);
        //获取当前的产液量
        QueryWrapper<AoidDailyYield> wrapper = new QueryWrapper<>();
        wrapper.eq("well_id",wellId).eq("prod_date",date);
        AoidDailyYield aoidDailyYield = aoidDailyYieldMapper.selectOne(wrapper);
        Double aDouble = Double.valueOf(avgForA2LiqProdDaily);
        double liqProdDaily = aoidDailyYield.getLiqProdDaily();
        double difference = aDouble-liqProdDaily;
        String result = "";
        int[] num = {15,10,5,1,0};
        double[] coefficient = {0.1,0.15,0.2,0.25,0.5};
        for (int i = 0 ;i< num.length; i++){
            if (aDouble>=num[i]){
                if (aDouble * (1-coefficient[i]) > liqProdDaily){
                    result = "液量异常";
                    break;
                }else {
                    result = "液量正常";
                    break;
                }
            }
        }
        //液量异常井 提取工况诊断是否正常，不正常 进入油井工况诊断 得出结论并输出 yuancheng wn_gk_msg context
        if (result.equals("液量异常")){
            String extractWorkingConditionDiagnosis = warningClint.extractWorkingConditionDiagnosis(wellId,date);
            if(extractWorkingConditionDiagnosis.equals("正常")){
                //正常 提取该井压力库数据，判断是否在高压区 默认 低压区
                //如处在低压区，查看 平均值与当日值的差是否大于0 ，大于0 分析为油井见效，输出结果;小于0 分析为能量不足，输出结果
                //如在高压区，查看 平均值与当日值的差是否大于0 ,大于0 分析为油井见效,输出结果;小于0分析为地层堵塞，输出结果
                if (difference > 0){
                    result = "油井见效";
                }else {
                    result = "能量不足";
                }
            }else{
                result = extractWorkingConditionDiagnosis;
            }
        }
        return result;
    }
}
