package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.algorithm.CalDiagramProduction;
import com.gct.aoid.algorithm.CalPumpCard;
import com.gct.aoid.entity.*;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.service.AoidCalprotaskqueueService;
import com.gct.aoid.service.AoidGkModelService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.AoidSinglewellConfigService;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * class name: CalDiagramProductionService
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:47
 */
@Component
public class CalDiagramProductionService {

    @Autowired
    private AoidCalprotaskqueueService aoidCalprotaskqueueService;
    @Autowired
    private BaseDataClient baseDataClient;
    @Autowired
    private DiagnoseClient diagnoseClient;
    @Autowired
    private AoidGkModelService aoidGkModelService;
    @Autowired
    private AoidSinglewellConfigService aoidSinglewellConfigService;
    @Autowired
    private CalPumpCard calPumpCard;
    @Autowired
    private CalDiagramProduction calDiagramProduction;
    @Autowired
    private AoidSinglegtYieldService aoidSinglegtYieldService;

    public void cal(String message) throws InstantiationException, IllegalAccessException {
        //if (message !=null ) return;
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        AoidCalprotaskqueue aoidCalprotaskqueue = JSONObject.parseObject(message,AoidCalprotaskqueue.class);
        String dcbpStr =null;
        DiagramCardBaseParam dcbp;
        SingleDiagramDiagnoseResult sddr;
        ProDataForCalProduction a2data;
        ProDataForCalProduction a2dataVol;
        try {
            dcbpStr = diagnoseClient.getDiagramCardBaseParamByID(aoidCalprotaskqueue.getSgtbaseparamId());
            dcbp = (DiagramCardBaseParam) JSONObject.parseObject(dcbpStr, Result.class).toFiguredOutObject(DiagramCardBaseParam.class);
            dcbp.setSgt(SGTUtil.encodeToDoubleArray(dcbp.getSgtStr()));
            String sddrStr = diagnoseClient.getSingleDiagramDiagnoseResultByID(aoidCalprotaskqueue.getDiagnoseresultId());
            sddr = (SingleDiagramDiagnoseResult) JSONObject.parseObject(sddrStr, Result.class).toFiguredOutObject(SingleDiagramDiagnoseResult.class);
            String a2dataStr = baseDataClient.getA2DataForCalProduction(dcbp.getWellName(),dcbp.getReceiveTime());
            a2data = (ProDataForCalProduction) JSONObject.parseObject(a2dataStr, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
            String a2dataStrVol = baseDataClient.getA2DataForCalVolDaily(dcbp.getWellName(), dcbp.getReceiveTime());
            a2dataVol = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVol, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
        }catch (Exception e){
            e.printStackTrace();
            throw  new RuntimeException("[aoid->CalDiagramProductionService->cal:] fegin error ");
        }
            AoidGkModel model = aoidGkModelService.getGKModelByResultType(sddr.getResult1());
            AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);
            Double[][] bgt = calPumpCard.cal_bgt(dcbp, sddr);

            CalDiagramProduction.CalProductionResult production = calDiagramProduction.calProduction(dcbp.getSgt(), bgt,
                    dcbp.getS(), dcbp.getN(), sddr.getResult1(), Double.valueOf(String.valueOf(a2data.getBj())), Double.valueOf(String.valueOf(a2data.getBs())),
                    Double.valueOf(String.valueOf(a2dataVol.getHsl()))/100 , Double.valueOf(String.valueOf(a2dataVol.getSmd())), Double.valueOf(String.valueOf(a2dataVol.getYmd())), Double.valueOf(String.valueOf(a2dataVol.getQyb())),
                    Double.valueOf(String.valueOf(a2data.getDym())), model.getGkxs(), effectStrockModel
            );
            aoidCalprotaskqueue.setStatus(AoidCalprotaskqueue.TaskStatus.COMPLETED.getCode());

        try {
            AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();
            aoidSinglegtYield.setWellId(dcbp.getWellName());
            aoidSinglegtYield.setWellCommonName(dcbp.getWellName());
            aoidSinglegtYield.setProdDate(LocalDateTime.parse(dcbp.getReceiveTime(),df));
            aoidSinglegtYield.setStroke(BigDecimal.valueOf(new BigDecimal(dcbp.getS()).setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setFrequence(BigDecimal.valueOf(new BigDecimal(dcbp.getN()).setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setBj(new BigDecimal(a2data.getBj().toString()).setScale(2, BigDecimal.ROUND_HALF_UP));
            aoidSinglegtYield.setBs(a2data.getBs());
            aoidSinglegtYield.setCmd(new BigDecimal(a2data.getBs().subtract(a2data.getDym()).toString()).setScale(3, BigDecimal.ROUND_HALF_UP));
            aoidSinglegtYield.setYzzj(a2data.getBj());
            aoidSinglegtYield.setSxzh(BigDecimal.valueOf(dcbp.getL_max()));
            aoidSinglegtYield.setXxzh(BigDecimal.valueOf(dcbp.getL_min()));
            aoidSinglegtYield.setSgt(SGTUtil.encodeToString(dcbp.getSgt()));
            aoidSinglegtYield.setBgt(SGTUtil.encodeToString(bgt));
            aoidSinglegtYield.setZdjg(sddr.getResult1());
            aoidSinglegtYield.setLiqProdDaily(BigDecimal.valueOf(new BigDecimal(production.rcyl).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setOilProdDaily(BigDecimal.valueOf(new BigDecimal(production.rcyl1).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setGasProdDaily(BigDecimal.valueOf(new BigDecimal(production.rcql).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setEczdjg(sddr.getResult2());
            aoidSinglegtYield.setBx(BigDecimal.valueOf(new BigDecimal(production.bx).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setHsl(new BigDecimal(a2dataVol.getHsl().toString()).setScale(3, BigDecimal.ROUND_HALF_UP));
            //aoidSinglegtYield.setFlag();
            //aoidSinglegtYield.setBdxs();
            aoidSinglegtYield.setLlpl(BigDecimal.valueOf(new BigDecimal(production.llpl).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setZcc(BigDecimal.valueOf(production.zcc));
            aoidSinglegtYield.setSjcc(BigDecimal.valueOf(new BigDecimal(production.sjcc ).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setYxcc(BigDecimal.valueOf(production.yxcc));
            aoidSinglegtYield.setCcss(BigDecimal.valueOf(production.ccss));
            aoidSinglegtYield.setLsss(BigDecimal.valueOf(production.lsss));
            aoidSinglegtYield.setGyss(BigDecimal.valueOf(production.gyss));
            aoidSinglegtYield.setHy(a2data.getBack_pres());
            aoidSinglegtYield.setYy(a2data.getTubing_pres());
            aoidSinglegtYield.setTy(a2data.getCasing_pres());
            aoidSinglegtYield.setWaterProdDaily(BigDecimal.valueOf(new BigDecimal(production.rcsl).setScale(2,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYield.setScsj(BigDecimal.valueOf(24));
            aoidSinglegtYield.setStrokeRatio(BigDecimal.valueOf(new BigDecimal(production.l_StrokeRatio).setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue()));
            /*aoidSinglegtYield.setDjdy();
            aoidSinglegtYield.setHjwd();
            aoidSinglegtYield.setYbdl();
            aoidSinglegtYield.setXhqd();
            aoidSinglegtYield.setSbh();*/
            aoidSinglegtYield.setSmd(a2dataVol.getSmd());
            aoidSinglegtYield.setYmd(a2dataVol.getYmd());
            aoidSinglegtYield.setQyb(BigDecimal.valueOf(new BigDecimal(a2dataVol.getQyb().toString()).setScale(1,BigDecimal.ROUND_HALF_UP).doubleValue()));
            aoidSinglegtYieldService.save(aoidSinglegtYield);
        }catch (Exception e){
           throw  new RuntimeException("[aoid->CalDiagramProductionService->cal:] insert Aoid_singlegt_yield table error ");
        }
    }
}
