package com.gct.aoid;

import com.gct.aoid.controller.AoidSinglegtYieldController;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.mapper.AoidSinglegtYieldMapper;
import com.gct.aoid.mapper.SumDataTaskMapper;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.aoid.service.impl.CalDiagramProductionService;
import com.gct.aoid.service.impl.SumDataTaskServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.math.BigDecimal;
import java.text.ParseException;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class MyTest {
    @Autowired
    CalDiagramProductionService calDiagramProductionService ;
    @Autowired
    BaseDataClient client;
    @Autowired
    DiagnoseClient diagnoseClient;
    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    AoidDailyYieldService aoidDailyYieldService;
    @Autowired
    AoidSinglegtYieldController aoidSinglegtYieldController;
    @Autowired
    AoidSinglegtYieldMapper aoidSinglegtYieldMapper;
    @Autowired
    SumDataTaskMapper sumDataTaskMapper;

    @Test
    public void test() throws InstantiationException, IllegalAccessException, ParseException {//test error  2021.1.25 19:17
        //aoidSinglegtYieldService.getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod("H257","2020-01-15");
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        AoidSinglegtYield aoidSinglegtYield = new AoidSinglegtYield();
        aoidSinglegtYield.setWellId("H257");
        aoidSinglegtYield.setWellCommonName("H257");
        aoidSinglegtYield.setProdDate(LocalDateTime.parse("2021-01-15 18:13:50", df));
        aoidSinglegtYield.setStroke(BigDecimal.valueOf(1L));
        aoidSinglegtYield.setFrequence(BigDecimal.valueOf(1));
        aoidSinglegtYield.setBj(BigDecimal.valueOf(1));
        aoidSinglegtYield.setBs(BigDecimal.valueOf(1));
        aoidSinglegtYield.setCmd(BigDecimal.valueOf(0));
        aoidSinglegtYield.setYzzj(BigDecimal.valueOf(1));
        aoidSinglegtYield.setSxzh(BigDecimal.valueOf(70.56));
        aoidSinglegtYield.setXxzh(BigDecimal.valueOf(32.57));
        aoidSinglegtYield.setSgt("04208,0,4192,2,4224,4,4256,7,4352,11,4496,14,4544,19,4576,25,4624,30,4704,37,4960,43,5120,51,5408,61,5584,68,5680,78,5936,89,6304,97,6528,109,6880,122,7056,130,7072,144,6944,153,6831,167,6559,181,6384,190,6352,205,6400,220,6559,230,6672,245,6831,259,6880,269,6864,284,6736,294,6656,309,6512,323,6431,332,6416,346,6464,360,6576,369,6623,382,6704,390,6704,402,6672,413,6592,421,6528,431,6431,441,6368,448,6352,456,6368,464,6400,469,6431,476,6448,480,6431,485,6384,490,6304,492,6256,495,6160,498,6128,499,6128,499,6144,499,6192,499,6208,497,6192,496,6160,492,6096,489,6064,485,6032,480,5952,474,5968,469,6000,462,6080,456,6096,448,6128,438,6128,432,6112,421,6048,410,5968,402,5952,390,5952,378,5968,369,5968,356,5984,347,5968,333,5744,319,5216,309,4864,294,4144,280,3600,270,3424,255,3247,240,3328,230,3488,215,3968,205,4192,191,4464,176,4432,167,4368,153,4128,140,3776,131,3632,118,3520,109,3568,97,3728,86,3984,78,4128,68,4320,58,4320,52,4288,43,4144,35,3952,30,3920,23,3952,19,4000,14,4096,9,4256,7,4336,4,4448,1,4416,0,4384,0,4288,");
        aoidSinglegtYield.setBgt("1799,16,151,17,182,19,191,23,182,27,167,31,162,35,188,39,258,41,385,42,571,42,811,41,1091,40,1389,40,1683,40,1949,43,2171,47,2335,53,2440,62,2489,72,2494,83,2470,96,2433,108,2396,121,2370,133,2360,145,2364,157,2378,169,2396,180,2411,192,2418,204,2414,216,2402,228,2384,239,2365,251,2351,262,2344,273,2346,283,2355,293,2367,304,2377,314,2380,324,2373,335,2355,345,2327,355,2293,365,2258,374,2228,382,2205,389,2193,395,2188,401,2188,406,2187,410,2180,415,2163,419,2133,422,2093,426,2047,428,2002,430,1964,429,1963,429,1939,428,1930,426,1937,423,1955,420,1976,415,1991,411,1994,406,1980,402,1949,397,1906,392,1859,385,1821,378,1801,369,1809,359,1845,348,1904,335,1974,323,2033,311,2059,300,2030,292,1929,286,1748,281,1488,279,1165,278,803,278,434,276,90,273,-196,268,-403,259,-518,248,-545,235,-497,220,-397,204,-275,189,-159,174,-74,162,-33,151,-42,141,-94,133,-175,126,-263,119,-340,112,-387,103,-394,94,-361,85,-295,75,-208,66,-118,57,-42,50,9,44,28,39,18,36,-16,33,-58,31,-96,29,-117,27,-113,24,-82,22,-29,");
        aoidSinglegtYield.setZdjg("1");
        aoidSinglegtYield.setLiqProdDaily(BigDecimal.valueOf(0.002384334652812909));
        aoidSinglegtYield.setOilProdDaily(BigDecimal.valueOf(0.002384334652812909));
        aoidSinglegtYield.setGasProdDaily(BigDecimal.valueOf(0.0028384936343010822));
        aoidSinglegtYield.setEczdjg("Pump break");
        aoidSinglegtYield.setBx(BigDecimal.valueOf(250.97794046327553));
        aoidSinglegtYield.setHsl(BigDecimal.valueOf(27));
        aoidSinglegtYield.setFlag(BigDecimal.valueOf(0));
        aoidSinglegtYield.setBdxs(BigDecimal.valueOf(1));
        aoidSinglegtYield.setLlpl(BigDecimal.valueOf(0.00113097335529233));
        aoidSinglegtYield.setZcc(BigDecimal.valueOf(0.166100679767287));
        aoidSinglegtYield.setSjcc(BigDecimal.valueOf(4.13653233085786));
        aoidSinglegtYield.setYxcc(BigDecimal.valueOf(2.50977940463276));
        aoidSinglegtYield.setCcss(BigDecimal.valueOf(0));
        aoidSinglegtYield.setLsss(BigDecimal.valueOf(0));
        aoidSinglegtYield.setGyss(BigDecimal.valueOf(1.6267529262251));
        aoidSinglegtYield.setHy(BigDecimal.valueOf(1));
        aoidSinglegtYield.setYy(BigDecimal.valueOf(1));
        aoidSinglegtYield.setTy(BigDecimal.valueOf(1));
        aoidSinglegtYield.setWaterProdDaily(BigDecimal.valueOf(0));
        aoidSinglegtYield.setScsj(BigDecimal.valueOf(24));
        aoidSinglegtYield.setStrokeRatio(BigDecimal.valueOf(99.6071472114813));
        for (int i = 0; i < 100; i++) {
            aoidSinglegtYieldMapper.insert(aoidSinglegtYield);
        }
    }


    @Test
    public void test1(){
        System.out.println(aoidDailyYieldService.getAoidDailyYieldInfoByWellIdAndPorDatePeriod("H257", "2021-01-15"));
        //System.out.println(aoidDailyYieldService.getAoidDailyYieldInfoByWellIdAndPorDatePeriod("H257", "2021-02-22"));
    }
    @Test
    //@Scheduled
    public void test2(){
        //System.out.println(client.getA2DataForCalProduction("H257", "2021-01-15 18:13:50"));
        System.out.println(client.getA2DataForCalVolDaily("H257", "2021-01-15 18:13:50"));

    }

    public static void main(String[] args) throws InterruptedException {

    }

}